
;-- INT 13 -------------------------------------------------------------
; DISKETTE I/O
;             5.25  360 KB,
;       1.2MB,720 KB, AND 1.44 MB 
; 
;       (AH)=OOH    
;          NEC,  
;----------------------------------------------------------------------------
;       (AH)=01H      (AH)
;                 DISKETTE_STATUS   
;----------------------------------------------------------------------------
;         //
;       (DL) -   (0-1 ,  )
;       (DH) -   (0-1 ALLOWED, NOT VALUE CHECKED)
;       (CH) -   (NOT VALUE CHECKED)
;                 MEDIA     DRIVE        TRACK NUMBER
;                320/360   320/360           0-39
;                320/360    1.2M             0-39
;                 1.2M      1.2M             0-79
;                 720K      720K             0-79
;                 1.44M     1.44M            0-79
;       (CL) -   (  ,   
;                            )
;                 MEDIA     DRIVE        SECTOR NUMBER
;                320/360   320/360            1-8/9
;                320/360    1.2M              1-8/9
;                 1.2M      1.2M              1-15
;                 720K      720K              1-9
;                 1.44M     1.44M             1-18
;       (AL) -   (  ,   
;			      )
;                 MEDIA     DRIVE        MAX NUMBER OF SECTORS
;                320/360   320/360               8/9
;                320/360    1.2M                 8/9
;                 1.2M      1.2M                 15
;                 720K      720K                  9
;                 1.44M     1.44M                18
;
;       (ES:BX) -   (   )
;
;---------------------------------------------------------------------------
;       (AH)=02H      
;----------------------------------------------------------------------------
;       (AH)=03H      
;----------------------------------------------------------------------------
;       (AH)=04H    
;----------------------------------------------------------------------------
;       (AH)=05H    
;                 (ES,BX)      
;                  .    4   (C,H,R,N),
;                 :
;                 C =  , H= , R =  ,
;		  N=     (00=128, 01=256, 02=512, 03=1024,)
;                   
;                       
;                  DISK_BASE     
;                 -------------------------------------------
;                 : MEDIA  :  DRIVE         : PARM1 : PARM2 :
;                 -------------------------------------------
;                 : 320K   : 320K/360K/1.2M :  50H  :   8   :
;                 : 360K   : 320K/360K/1.2M :  50H  :   9   :
;                 : 1.2M   :    1.2M        :  54H  :  15   :
;                 : 720K   :  720K/1.44M    :  50H  :   9   :
;                 : 1.44M  :  1.44M         :  6CH  :  18   :
;                 -------------------------------------------
;                 :-PARM 1=  
;                         -PARM 2=EOT (   )
;                         -DISK_BASE     
;                               0:78
;------------------------------------------------------------------------------
;       (AH)=08H   
;         INPUT
;           (DL)-  (0-1  )
;         OUTPUT
;           (ES:DI)    
;           (CH)-   ( 8 )
;           (CL)-  (   
;		  
;           (DH)-  
;------------------------------------------------------------------------------
;15H AT  ⨯ ᪠ (㯭  XT BIOS)
;     室: DL = 
;    室: AH =  ன⢠:
;                0 = ன⢮ DL 
;                1 = ᪥;   ᪠ 
;                2 = ᪥;   ᪠ 㯭 (設⢮ 砥)
;                3 = ⢥ 
; 
;16H AT    ᪠
;    室: AH =  :
;                0 =    
;                6 =  ⨢ ( ᪮ );
;                    DL =  塞 ᪠
; 
;17H AT ⠭ ⨯ ᪥ (ᯮ । 樥 ଠ஢)
;     室: DL =  ன⢠ ᪠ (0  1)
;           AL = ⨯ ⥫ ᪠:
;                0 =  ᯮ
;                1 = 360K ᪥  360K ன⢥
;                2 = 360K ᪥  1.2M ன⢥
;                3 = 1.2M ᪥  1.2M ன⢥
;
;       (AH)=18H    
;        
;       (CH) -  8  10  -     
;       (CL) -  7  6 -      
;            -  5 - 0 -    
;       (DL) -   (0-1  )
;        
;       (ES:DI) -       ,
;		   AH 
;       (AH) - 00H, CY=0 ,  
;              01H, CY=1 ,   
;              0CH, CY=1 ,   
;                           
;            - 80H, CY=1 ,TIME OUT (  )
;-----------------------------------------------------------------------------
;
;      -   40:90 ( A)  91 ( B)
;
;   -----------------------------------------------------------------
;   |       |       |       |       |       |       |       |       |
;   |   7   |   6   |   5   |   4   |   3   |   2   |   1   |   0   |
;   |       |       |       |       |       |       |       |       |
;   -----------------------------------------------------------------
;       |       |       |       |       |       |       |       |
;       |       |       |       |       |       -----------------
;       |       |       |       |       |               |
;       |       |       |       |                 -- 
;       |       |       |       |
;       |       |       |       |        000: 360K  360K   
;       |       |       |       |        001: 360K  1.2M   
;       |       |       |       |        010: 1.2M  1.2M   
;       |       |       |       |        011: 360K  360K  
;       |       |       |       |        100: 360K  1.2M  
;       |       |       |       |        101: 1.2M  1.2M  
;       |       |       |       |        110: 
;       |       |       |       |        111:  
;       |       |       |       |
;       |       |       |       ------> / 
;       |       |       |
;       |       |       -------------->   360K  1.2M
;       |       |
;       |       |
;       ------------------------------>      
;
;                                               00: 500 KBS
;                                               01: 300 KBS
;                                               10: 250 KBS
;                                               11: 
;--------------------------------------------------------------------------------

        ORG     0EC59H

DISKETTE_IO     PROC    FAR
        STI
        PUSH    BP
        PUSH    DI
        PUSH    DX
        PUSH    BX
        PUSH    CX
        MOV     BP,SP
        PUSH    DS
        PUSH    SI
        CALL    DDS

        MOV	LowLim,AX
        MOV	UPPP,055H
REPID_YES:        
	not	uppp
        CMP     AH,19H
                                        ;   19H 
        JB      OK_FUNC
        MOV     AH,14H
OK_FUNC:
        CMP     AH,1                    ;  1  8 
        JBE     OK_DRV                  ;
        CMP     AH,8                    ;
        JE      OK_DRV                  ;
        CMP     DL,1                    ;
        JBE     OK_DRV                  ;
        MOV     AH,14H                  ;
OK_DRV :
        MOV     CL,AH                   ;    
        XOR     CH,CH                   ;
        SHL     CL,1                    ;
        MOV     BX,OFFSET FNC_TAB       ;
        ADD     BX,CX                   ;
        MOV     AH,DH                   ;
        XOR     DH,DH                   ;
        MOV     SI,AX                   ;
        MOV     DI,DX                   ;
        MOV     AH,DISKETTE_STATUS      ;  DISKETTE_STATUS
        MOV     DISKETTE_STATUS,0       ;

;                 
;        .        
;       
;
;               DI      :  #
;               SI-HI   :   #
;               SI-LOW  : #    DASD  
;               ES      :  
;               [BP]    :  #
;               [BP+1]  :  #
;               [BP2]   : BUFFER OFFSET
;
                                        ;
        CALL    WORD PTR CS:[BX]        ;    
        JNC	EXIT_OP
        CMP	UPPP,0AAH
        JNE	EXIT_OP
        MOV	AX,LowLim
        MOV	CX,[BP]
        MOV	BX,[BP+2]
        MOV	DX,[BP+4]
        JMP	REPID_YES
EXIT_OP:               
        POP     SI                      ;
        POP     DS
        POP     CX
        POP     BX
        POP     DX
        POP     DI
        MOV     BP,SP
        PUSH    AX
        PUSHF
        POP     AX
        MOV     [BP+6],AX
        POP     AX
        POP     BP
        IRET
;----------------------------------------------------------------------------
FNC_TAB DW      DISK_RESET              ; AH = 00H; 
        DW      DISK_STATUS             ; AH = 01H; 
        DW      DISK_READ               ; AH = 02H; 
        DW      DISK_WRITE              ; AH = 03H; 
        DW      DISK_VERF               ; AH = 04H; 
        DW      DISK_FORMAT             ; AH = 05H; 
        DW      FNC_ERR                 ; AH = 06H;  
        DW      FNC_ERR                 ; AH = 07H;  
        DW      DISK_PARMS              ; AH = 08H;   
        DW      FNC_ERR                 ; AH = 09H;  
        DW      FNC_ERR                 ; AH = 0AH;  
        DW      FNC_ERR                 ; AH = 0BH;  
        DW      FNC_ERR                 ; AH = 0CH;  
        DW      FNC_ERR                 ; AH = 0DH;  
        DW      FNC_ERR                 ; AH = 0EH;  
        DW      FNC_ERR                 ; AH = 0FH;  
        DW      FNC_ERR                 ; AH = 10H;  
        DW      FNC_ERR                 ; AH = 11H;  
        DW      FNC_ERR                 ; AH = 12H;  
        DW      FNC_ERR                 ; AH = 13H;  
        DW      FNC_ERR                 ; AH = 14H;  
        DW      DISK_TYPE               ; AH = 15H;  DASD 
        DW      DISK_CHANGE             ; AH = 16H;  
        DW      FORMAT_SET              ; AH = 17H;  DASD 
        DW      SET_MEDIA               ; AH = 18H;   
FNC_TAE EQU     $                       ; 
DISKETTE_IO     ENDP

MD_STRUC        STRUC
MD_SPEC1        DB      ?       ; SRT=D,HD UNLOAD=OF -IST SPECIFY BYTE
MD_SPEC2        DB      ?       ; HD LOAD=1,MODE=DMA -2ND SPECIFY BYTE
MD_OFF_TIM      DB      ?       ;             
MD_BYT_SEC      DB      ?       ; 512 /
MD_SEC_TRK      DB      ?       ; EQT (   )
MD_GAP          DB      ?       ;   
MD_DTL          DB      ?       ; DTL
MD_GAP3         DB      ?       ;   
MD_FIL_BYT      DB      ?       ;    
MD_HD_TIM       DB      ?       ;    ()
MD_STR_TIM      DB      ?       ;    ( 1/8 )
MD_MAX_TRK      DB      ?       ;   
MD_RATE         DB      ?       ;   
MD_STRUC        ENDS

TYPEDSK		EQU	42h    ;43H     ;   !!! A=720K  B=1.44M

BIT7OFF         EQU     7FH
BIT7ON          EQU     80H

;--------- DISKETTE ERRORS-

MED_NOT_FND     EQU     00CH            ;   

;----------/  

TRK_CAPA        EQU     00000001B       ;80     
FMT_CAPA        EQU     00000010B       ; (1.2MB)
DRV_DET         EQU     00000100B       ;  
MED_DET         EQU     00010000B       ;  
DBL_STEP        EQU     00100000B       ;  
RATE_MSK        EQU     11000000B       ;     
RATE_250        EQU     10000000B       ;250 KBS  
RATE_300        EQU     01000000B       ;300 KBS  
RATE_500        EQU     00000000B       ;500 KBS  
STRT_MSK        EQU     00001100B       ;   
SEND_MSK        EQU     11000000B       ;    

;----------/  

M3D3U           EQU     00000000B       ;360 /  
M3D1U           EQU     00000001B       ;360 ,1.2  
M1D1U           EQU     00000010B       ;1.2 /  
MED_UNK         EQU     00000111B       ;    

;----------CMOS  

CMOS_DIAG       EQU     00EH            ;                    
CMOS_DISKETTE   EQU     010H            ;          



;------------------------------------------------------------------------------
;         
;----------------------------------------------------------------------------
DR_TYPE         DB      01              ;              
                DW      OFFSET MD_TBL1
                DB      02+BIT7ON
                DW      OFFSET MD_TBL2
DR_DEFAULT      DB      02
                DW      OFFSET MD_TBL3
                DB      03
                DW      OFFSET MD_TBL4
                DB      04+BIT7ON
                DW      OFFSET MD_TBL5
                DB      04
                DW      OFFSET MD_TBL6
DR_TYPE_E       =$                      ;  
DR_CNT          EQU     (DR_TYPE_E-DR_TYPE)/3
;--------------------------------------------------------------------------
;       /                                :
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
;       360 KB   360                                    :
;--------------------------------------------------------------------------
MD_TBL1         LABEL BYTE
        DB      11011111B       ; SRT=D,HD UNLOAD=OF-1ST SPECIFY BYTE
        DB      2               ; HD LOAD=1,MODE=DMA-2ND SPECIFY BYTE
        DB      MOTOR_WAIT      ;          
        DB      2               ; 512   
        DB      09              ; EOT (    )
        DB      02AH            ;   
        DB      0FFH            ; DTL
        DB      050H            ;   
        DB      0F6H            ;       
        DB      15              ;    ()
        DB      8               ;    ( 1/8 ) 
        DB      39              ;              
        DB      RATE_250        ;                
;------------------------------------------------------------------------------
;       360 KB  1.2 MB                                     :
;-----------------------------------------------------------------------------
MD_TBL2         LABEL BYTE
        DB      11011111B       ; SRT=D,HD UNLOAD=OF-1ST SPECIFY BYTE    
        DB      2               ; HD LOAD=1,MODE=DMA-2ND SPECIFY BYTE    
        DB      MOTOR_WAIT      ;         
        DB      2               ; 512                        
        DB      09              ; EOT (    )     
        DB      02AH            ;                 
        DB      0FFH            ; DTL                                    
        DB      050H            ;             
        DB      0F6H            ;         
        DB      15              ;    ()  
        DB      8               ;    ( 1/8 )   
        DB      39              ;                
        DB      RATE_300        ;                  
;----------------------------------------------------------------------------
;       1.2 MB  1.2 MB                                     :
;---------------------------------------------------------------------------
MD_TBL3         LABEL BYTE
        DB      11011111B       ; SRT=D,HD UNLOAD=OF-1ST SPECIFY BYTE    
        DB      2               ; HD LOAD=1,MODE=DMA-2ND SPECIFY BYTE    
        DB      MOTOR_WAIT      ;         
        DB      2               ; 512                        
        DB      15              ; EOT (    )     
        DB      01BH            ;                 
        DB      0FFH            ; DTL                                    
        DB      054H            ;             
        DB      0F6H            ;         
        DB      15              ;    ()  
        DB      8               ;    ( 1/8 )   
        DB      79              ;                
        DB      RATE_500        ;                  
;-----------------------------------------------------------------------------
;       720 KB  720 KB                                        :
;-----------------------------------------------------------------------------
MD_TBL4         LABEL BYTE
        DB      11011111B       ; SRT=D,HD UNLOAD=OF-1ST SPECIFY BYTE    
        DB      2               ; HD LOAD=1,MODE=DMA-2ND SPECIFY BYTE    
        DB      MOTOR_WAIT      ;         
        DB      2               ; 512                        
        DB      09              ; EOT (    )     
        DB      02AH            ;                 
        DB      0FFH            ; DTL                                    
        DB      050H            ;             
        DB      0F6H            ;         
        DB      15              ;    ()  
        DB      8               ;    ( 1/8 )   
        DB      79              ;                
        DB      RATE_250        ;                  
;----------------------------------------------------------------------------
;       720 KB  1.44 MB                                      :
;----------------------------------------------------------------------------

MD_TBL5         LABEL BYTE
        DB      11011111B       ; SRT=D,HD UNLOAD=OF-1ST SPECIFY BYTE    
        DB      2               ; HD LOAD=1,MODE=DMA-2ND SPECIFY BYTE    
        DB      MOTOR_WAIT      ;         
        DB      2               ; 512                        
        DB      09              ; EOT (    )     
        DB      02AH            ;                 
        DB      0FFH            ; DTL                                    
        DB      050H            ;             
        DB      0F6H            ;         
        DB      15              ;    ()  
        DB      8               ;    ( 1/8 )   
        DB      79              ;                
        DB      RATE_250        ;                  
;----------------------------------------------------------------------------
;       1.44 MB  1.44 MB                                    :
;----------------------------------------------------------------------------

MD_TBL6         LABEL BYTE
        DB      10101111B       ; SRT=D,HD UNLOAD=OF-1ST SPECIFY BYTE    
        DB      2               ; HD LOAD=1,MODE=DMA-2ND SPECIFY BYTE    
        DB      MOTOR_WAIT      ;         
        DB      2               ; 512                        
        DB      18              ; EOT (    )     
        DB      01BH            ;                 
        DB      0FFH            ; DTL                                    
        DB      06CH            ;             
        DB      0F6H            ;         
        DB      15              ;    ()  
        DB      8               ;    ( 1/8 )   
        DB      79              ;                
        DB      RATE_500        ;                  

;-------------------------------------------------------------------------
;DISK_BASE
;            
;        .   DISK_POINTER
;            
;              DISK_POINTER      
;-------------------------------------------------------------------------
        ORG     0EFC7H
DISK_BASE       LABEL  BYTE
        DB      10011111B     ;SRT=9,HD UNLOAD=0F-IST SPECIFY BYTE
        DB      2             ;HD LOAD=1,MODE=DMA-2ND SPECIFY BYTE
        DB      MOTOR_WAIT    ;       
        DB      2             ; 512                      
        DB      18            ; EOT (    )   
        DB      02AH          ;               
        DB      0FFH          ; DTL                                  
        DB      050H          ;           
        DB      0F6H          ;       
        DB      25            ;    ()
        DB      4             ;    ( 1/8 ) 

